/* ---------------------------------------------------------------------------
 *  This software is in the public domain, furnished "as is", without technical
 *  support, and with no warranty, express or implied, as to its usefulness for
 *  any purpose. For more see LICENSE.txt that has to accompany this file.
 *
 *  ProgressReporter.cpp
 *
 *  Copyright Aleksey Boyko, Princeton University, 2013.
 *
 *  Description: Simple progress reporter class.
 *
 *  -------------------------------------------------------------------------*/

#include "ProgressReporter.h"

namespace igra {

ProgressReporter::ProgressReporter(const char *message, bool report, FILE *io) :
                dev_(io),
                msg_(strdup(message)),
                term_stat_(NULL),
                print_(report),
                timer_() {
    timer_.Read();
    update(0.0);
}

ProgressReporter::~ProgressReporter() {
    update(100.0);
    if (print_) {
        fprintf(dev_, "\tDone in %.2f seconds.", timer_.Elapsed());
        if (term_stat_) fprintf(dev_, "Status = %s", term_stat_);
        fprintf(dev_, "\n");
    }
    if (msg_) free(msg_);
    if (term_stat_) free(term_stat_);
}

} //namespace igra
